Subject: Re: [PATCH 5/6] PowerPC 440EPx: Sequoia board support

From: Benjamin Herrenschmidt <[email-masked]>
Date: Sat, 06 Oct 2007 08:17:52 +1000

On Fri, 2007-10-05 at 22:36 +0400, Valentine Barshak wrote:
> Benjamin Herrenschmidt wrote:
> >> Depends on interpretation. IIRC currently the same die is used for 440EPx and 
> >> 440GRx. I could be wrong here though and it is just a bug in the chip. But 
> >> anyway we should support this somehow. Could be that I missed this in the 
> >> current 440GRx (Rainier) arch/ppc support too. I have to admit, that no 
> >> clever solution comes to my mind right away though.
> > 
> > We can always come up with some kind of runtime detection, by turning on
> > MSR:FP, issuing an fp instruction and catching the illegal instruction
> > fault if any :-)
> > 
> > Ben.
> > 
> > 
> 
> Is it OK to workaround the GRX/EPX having the same PVR issue using 
> device tree?
> Say, check the PVR value and if we have 440EPx PVR, but 440GRX node in 
> the device tree, fix the cputable entry and omit FPU initialization code.

Fixing the CPU features based on the tree is definitely legit. We do
that on pseries. In fact, with paulus latest patch, the cputable is
__initdata and the cur CPU features is a -copy- which makes it even more
legitimate to whack it.

Ben.